using CFX;
using HslCommunication;
using Sln.Iot.CFX.CFXConnect;
using Sln.Iot.CFX.Event;
using Sln.Iot.PLC;
using Sln.Iot.Repository.service;
using Sln.Iot.Serilog;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;

namespace Sln.Iot.Business
{
    public class RFID03Business
    {
        private Timer _timer;

        private readonly PLCConnect _plc = PLCConnect.Instance;

        private readonly SerilogHelper _log = SerilogHelper.Instance;

        private TrayBindingService trayBindingService = TrayBindingService.Instance;
        private WorkStageStartedEvent workStageStartedEvent = new WorkStageStartedEvent();
        private WorkStageCompletedEvent workStageCompletedEvent = new WorkStageCompletedEvent();
        private CFXConnect1 connect1 = CFXConnect1.Instance;
        private CFXConnect2 connect2 = CFXConnect2.Instance;
        private CFXConnect3 connect3 = CFXConnect3.Instance;

        public RFID03Business()
        {
            _timer = new Timer(TimerCallback, null, 0, 2000);
        }

        /// <summary>
        /// RFID03胶机1真空箱外数据处理流程
        /// </summary>
        /// <param name="state"></param>
        public void TimerCallback(object? state)
        {
            try
            {
                // 定时任务逻辑
                //读取信号
                OperateResult<short> signalRes = _plc.ReadInt16(_plc.DeltaInstance1, "D802");
                //成功验证
                if (signalRes.IsSuccess)
                {
                    short signalValue = signalRes.Content;
                    //如果有读取信号
                    if (signalValue == 3001)
                    {
                        //读取托盘码
                        OperateResult<byte[]> trayBytesResult = _plc.ReadBytes(_plc.DeltaInstance1, "D5020", 10);
                        //成功验证
                        if (trayBytesResult.IsSuccess)
                        {
                            //转换托盘码
                            string traycode = Encoding.ASCII.GetString(trayBytesResult.Content);
                            _log.Info("RFID03" + traycode);

                            //sql更新
                            //取出work唯一guid(tid)
                            string stid = trayBindingService.TidGet(traycode);
                            Guid.TryParse(stid, out Guid tid);

                            bool res = trayBindingService.UpDateTime(DateTime.Now.ToString(), traycode, "1");
                            if (!res)
                            {
                                _log.Error("胶机1真空箱外数据库写入异常");
                            }

                            //写入完成信号
                            res = _plc.PlcWrite(_plc.DeltaInstance1, "D802", 3002, DataTypeEnum.UInt16).IsSuccess;
                            if (!res)
                            {
                                _log.Error("胶机1真空箱外写入完成信号异常");
                            }

                            //CFX
                            Task.Run(() =>
                            {
                                //真空箱1工段完成事件
                                connect1.PublishEvent(new CFXEnvelope(workStageCompletedEvent.Handle(tid, "VacuumInjection1", 1)));
                                _log.Info($"真空箱1工段完成, {tid}");
                                //预固炉工段开启
                                connect3.PublishEvent(new CFXEnvelope(workStageStartedEvent.Handle(tid, "PreCureOven", 2)));
                                _log.Info($"预固炉工段开启, {tid}");
                            });
                        }
                        //流程完成
                    }
                }
                else
                {
                    _log.Error("胶机1真空箱外PLC读取信号异常");
                }
            }
            catch (Exception ex)
            {
                _log.Error("RFID0业务出现异常", ex);
            }
        }
    }
}
